;**********************************************************************************************************
;Author: Gio
;Program: Pong.exe
;Program's Purpose: A vey basic pong game where you move a paddle Up and Down about a  boundary, preventing a ball from
;			  getting pass.
;**********************************************************************************************************

	.586
	.MODEL	FLAT, STDCALL
	OPTION	CASEMAP : NONE
	
	;Include required files for accessing several windows API functions, also theres a randomizer library included
	INCLUDE		\MASM32\INCLUDE\WINDOWS.INC
	INCLUDE		\MASM32\INCLUDE\GDI32.INC
	INCLUDE		\MASM32\INCLUDE\USER32.INC
	INCLUDE		\MASM32\INCLUDE\KERNEL32.INC
	INCLUDELIB	\MASM32\LIB\RANDOMAM.LIB
	INCLUDELIB	\MASM32\LIB\GDI32.LIB
	INCLUDELIB	\MASM32\LIB\USER32.LIB
	INCLUDELIB	\MASM32\LIB\KERNEL32.LIB
	
;Function prototypes to create pong game
MRandomInit		PROTO C :DWORD
MIRandom		PROTO C :DWORD, :DWORD
Randomize		PROTO	:DWORD, :DWORD
WinMain			PROTO	:HINSTANCE, :HINSTANCE, :LPSTR, :DWORD
WndProc			PROTO	:DWORD, :DWORD, :DWORD, :DWORD
PutBallInCenter	PROTO	:DWORD
MoveBall		PROTO	:DWORD
MovePaddleUp1	PROTO	:DWORD
MovePaddleDown1	PROTO	:DWORD
MovePaddleUp2	PROTO	:DWORD
MovePaddleDown2	PROTO	:DWORD
SetBallArea		PROTO
SetPaddleArea1	PROTO
SetPaddleArea2	PROTO
Computer		PROTO	:DWORD
Sound			PROTO	:DWORD, :DWORD
	
;Data which are Initialized
	.DATA
;IDs for the application's window, main program, program icon, logo, and others. Most noteable, the .ico, .bmp files are loaded from the resource table and are given references.
ClassName	DB		"Pong", 0	;class identification name
AppName		DB		"Pong", 0	;application identification name
pong_icon	DB		"pong_icon", 0	;gets pong icon identifier from program's resouce table
pong_logo	DB		"pong_logo", 0 ;gets pong logo  identifier from program's resource table
Paddle		DB		"Paddle", 0	;gets Paddle bitmap identifier from program's resource table
Ball		DB		"Ball", 0	;gets Ball bitmap identifier from program's resource table

;default setting for the paddles positions off the nearest left or right side of the window. Here they will be 20 pixels away from their prospective side boundaries
awayPos		DD		20

;holds the width and height of the window created for game play.
nWidth		DD		600
nHeight		DD		300

;Variations which control game variations in ball speed, paddle pace, and enables and disables ball animation
pace1		DWORD	30		;pace of left paddle. Note: the lower the pace, the slower the paddle moves, and the more accurate the movement gets. Moves are in pixels.
pace2		DWORD	10		;pace of right paddle
speed		DWORD	2		;speed at which ball moves in both x-y direction of motion. Default speed is 2.
compRR		DWORD	50		;Computer's response rate. Note: if speed is ignored then computer response rate should decrease to correlate to 1 for maximum response.
ignoreSpeed	BOOL	FALSE	;if the option is true, then the ball will increase in speed exponentially without regards to a controlled gameplay.
resumePlay	BOOL	TRUE	;each time the ball runs out on either player's side, then pauses. Making this option true resumes game play.
stopComp	BOOL	TRUE	;Stops computer's paddle from moving at any given point

;Misc. variables
sndFreq		DWORD	400	;default frequency
sndDur		DWORD	15	;default durationn period of frequency
sndEnable	BOOL	TRUE ;enables/disables game sound

;Variables that are Unitialised
	.DATA?
hInstance	DD		?	;will hold handle to console window
PaddleDC	DWORD	?	;device context of for paddle bitmaps.
PaddleBmp	DWORD	?	;variable to reference an address to the paddle bitmap obtained from the resource table.
padStruct	BITMAP	<>	;holds paddle bitmap demensions
TempRect	RECT	<>	;temporary storage for demsions to any rectangle
BallDC		DWORD	?	;ball device context (a DC is a memory location to hold bitmaps, pens, fonts etc, for use with the windows GDI (graphical device interface).
BallBmp		DWORD	?	;will reference to ball bitmap later on
ballStruct	BITMAP	<>	;holds ball bitmap demensions

;Variables required for thread-processing
BallThrd	DB		?		;identifier to ball's thread process
hBallThrd	HANDLE	?		;handle to ball's thread process
CompThrd	DB		?		;identifier to computer's thread process
hCompThrd	HANDLE	?		;handle to computer's thread process

;Holds  ball, and both left and right paddles current position, depending on setting of the current window size
ballPos		RECT	<>
paddlePos1	RECT	<>
paddlePos2	RECT	<>

	.CODE
start:		;program starts here
	INVOKE	GetModuleHandle, NULL	;obtains instance for a new window context
	mov		hInstance, eax			;stores instance returned in the eax
	INVOKE	WinMain, hInstance, NULL, NULL, SW_SHOWNORMAL	;invokes and instance of the pong game window.
	INVOKE	ExitProcess, eax	;Completely kills program by exiting all opened processes and threads.
	
;for all windows 32-based programs, this is the initial program startup function
WinMain	PROC	hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG
	LOCAL	hwnd:HWND
		
		mov		wc.cbSize, SIZEOF WNDCLASSEX
		mov		wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
		mov		wc.lpfnWndProc, OFFSET WndProc
		mov		wc.cbClsExtra, NULL
		mov		wc.cbWndExtra, NULL
		push	hInstance							;Cannot move from memory to memory so we push this address to the stack
		pop		wc.hInstance						;Then pop and copy it to the windows class
		mov		wc.hbrBackground, COLOR_WINDOW+2	;class handle brush will paint the window background black
		mov		wc.lpszClassName, OFFSET ClassName
		INVOKE	LoadIcon, hInstance, Addr pong_logo
		mov		wc.hIcon, eax
		INVOKE	LoadIcon, hInstance, Addr pong_icon
		mov		wc.hIconSm, eax
		INVOKE	LoadCursor, NULL, IDC_ARROW
		mov		wc.hCursor, eax
		INVOKE	RegisterClassEx, Addr wc	;registers the window class instance
		INVOKE	CreateWindowEx, WS_EX_LEFT, Addr ClassName, Addr AppName,\
				WS_OVERLAPPEDWINDOW-WS_MAXIMIZEBOX-WS_SIZEBOX, CW_USEDEFAULT,\
				CW_USEDEFAULT, nWidth, nHeight, NULL, NULL, hInst, NULL
		mov		hwnd, eax
		INVOKE	ShowWindow, hwnd, CmdShow
		INVOKE	UpdateWindow, hwnd
		.WHILE	TRUE
			INVOKE	GetMessage, Addr msg, NULL, 0, 0
			.BREAK	.IF	(!eax)							;breaks from loop whenever EX a quit message has been processed. A quit, indicated by 0 is F.
			INVOKE	TranslateMessage, Addr msg			;interprets and pushes whatever messages recieved from the window to the msg queue
			INVOKE	DispatchMessage, Addr msg			;invokes the WinProc procedure to handle all messages recieved
		.ENDW
		mov	eax, msg.wParam
		ret
WinMain	ENDP

;Procedure function control all messages sent to the application window
WndProc PROC	hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	hDC:DWORD
	LOCAL	PS:PAINTSTRUCT
	LOCAL	Rect:RECT
	
		mov		eax, uMsg
			.IF	eax == WM_CREATE
				INVOKE	GetClientRect, hWnd, Addr Rect
				INVOKE	GetDC, hWnd
				mov	hDC, eax
				INVOKE	CreateCompatibleDC, hDC	;creates a new device context that can hold a bitmap
				mov	PaddleDC, eax
				INVOKE	LoadBitmap, hInstance, Addr Paddle ;loads the bitmap from the resource file table
				mov	PaddleBmp, eax
				INVOKE	GetObject, PaddleBmp, SIZEOF padStruct, Addr padStruct
				INVOKE	SelectObject, PaddleDC, PaddleBmp		;puts the bitmap into the newly created device context
				mov	eax, Rect.bottom
				sub	eax, padStruct.bmHeight
				shr	eax, 1
				mov	paddlePos1.top, eax
				mov	paddlePos2.top, eax
				mov	eax, awayPos
				mov	paddlePos1.left, eax
				mov	eax, Rect.right
				sub	eax, padStruct.bmWidth
				sub	eax, awayPos
				mov	paddlePos2.left, eax
				INVOKE	SetPaddleArea1
				INVOKE	SetPaddleArea2
				
				INVOKE	CreateCompatibleDC, hDC
				mov	BallDC, eax
				INVOKE	LoadBitmap, hInstance, Addr Ball
				mov	BallBmp, eax
				INVOKE	GetObject, BallBmp, SIZEOF ballStruct, Addr ballStruct
				INVOKE	SelectObject, BallDC, BallBmp
				
				INVOKE	PutBallInCenter, hWnd
				INVOKE	CreateThread, NULL, 0, Addr MoveBall, hWnd, CREATE_SUSPENDED, Addr BallThrd
				mov	hBallThrd, eax
			.ELSEIF	eax == WM_PAINT		;Repaints window each time something changes are made such as the paddles and ball moving about.
				INVOKE	BeginPaint, hWnd, Addr PS
				mov	hDC, eax
				INVOKE	BitBlt, hDC, paddlePos1.left, paddlePos1.top, padStruct.bmWidth, padStruct.bmHeight,\
						PaddleDC, 0, 0,	SRCCOPY
				INVOKE	BitBlt, hDC, paddlePos2.left, paddlePos2.top, padStruct.bmWidth, padStruct.bmHeight,\
						PaddleDC, 0, 0, SRCCOPY
				INVOKE	BitBlt, hDC, ballPos.left, ballPos.top, ballStruct.bmWidth, ballStruct.bmHeight,\
						BallDC, 0, 0, SRCCOPY
				INVOKE	EndPaint, hWnd, Addr PS
			.ELSEIF	eax == WM_KEYDOWN
				mov	eax, wParam
				
				.IF	(eax == VK_SPACE || eax == VK_RETURN)	;Virtual Key: Space or Return keys
					INVOKE	ResumeThread, hBallThrd
					.IF	resumePlay == FALSE
						mov	resumePlay, TRUE
						INVOKE	PutBallInCenter, hWnd
						INVOKE	InvalidateRect, hWnd, NULL, TRUE
						INVOKE	CreateThread, NULL, 0, Addr MoveBall, hWnd, CREATE_SUSPENDED, Addr BallThrd
						mov	hBallThrd, eax
					.ENDIF
				.ENDIF
				
				.IF	eax == VK_UP		;Virtual Key: Up
					INVOKE	MovePaddleUp1, hWnd
				.ELSEIF eax == VK_DOWN	;Virtual Key: Down
					INVOKE	MovePaddleDown1, hWnd
				.ENDIF
			.ELSEIF	eax	== WM_DESTROY
				;destroys the Device Contexts (DCs) used by the program
				INVOKE	DeleteDC, PaddleDC
				INVOKE	DeleteObject, Paddle
				INVOKE	PostQuitMessage, NULL
			.ElSE
				INVOKE	DefWindowProc, hWnd, uMsg, wParam, lParam		;calls windows procedure for unprocessed messages
				ret
			.ENDIF
		ret
WndProc	ENDP

;Computer A.I. procedure
Computer	PROC hWnd:DWORD
	LOCAL	Rect:RECT
	
		INVOKE	GetClientRect, hWnd, Addr Rect
		mov	eax, Rect.right
		shr	eax, 1
		mov	ebx, eax
		
		.WHILE (ballPos.right < ebx)
			INVOKE	Sleep, 25
		.ENDW
		
		
		.WHILE (ballPos.right >= ebx) && (stopComp != TRUE)
			INVOKE	SetBallArea
			mov	eax, ballPos.top
			add	eax, ballPos.bottom
			shr	eax, 1
			INVOKE	SetPaddleArea2
			mov	ebx, paddlePos2.top
			add	ebx, paddlePos2.bottom
			shr	ebx, 1
			.IF(eax	< ebx)
				INVOKE	MovePaddleUp2, hWnd
			.ELSEIF(eax > ebx)
				INVOKE	MovePaddleDown2, hWnd
			.ENDIF
			mov	eax, compRR
			INVOKE	Sleep, eax
		.ENDW
	ret
Computer	ENDP

;places the ball in the center of the client box of the main window
PutBallInCenter	PROC	hWnd:DWORD
	LOCAL	Rect:RECT
	INVOKE	GetClientRect, hWnd, Addr Rect
	;---------Centers ball-------------
	mov	edi, Rect.right
	sub	edi, ballStruct.bmWidth
	shr	edi, 1
	mov	ballPos.left, edi	;ball is placed at this X location, pixel units, within client rectangle
	mov	edi, Rect.bottom
	sub	edi, ballStruct.bmHeight
	shr	edi, 1
	mov	ballPos.top, edi	;ball is placed at this Y location, pixel units, within client rectangle
	ret
PutBallInCenter	ENDP


;Controls ball movement about the window client area
MoveBall	PROC	hWnd:DWORD
	LOCAL	hDC:HDC
	LOCAL	Rect:RECT
	LOCAL	yDelta:DWORD	;change in Y direction
	LOCAL	xDelta:DWORD	;change in X direction
	LOCAL	xy:BYTE			;holds the signed-wise direction of X and Y as they progress in one direction.
	LOCAL	entropy:BOOL	;Entropy determines wether the ball's motion and velocity will be altered. Enabling entropy enables randomization making game more fun.
	LOCAL	guess:DWORD
	
	INVOKE	GetClientRect, hWnd, Addr Rect
	INVOKE	SetBallArea
	mov	ebx, speed
	mov	xDelta, ebx
	mov	yDelta, ebx
	mov	xy, 0FFH ;move in a up-right direction, ie: as the X and Y direction increases, there positions become + and - respectively.
	mov	entropy, TRUE
	
	INVOKE	Randomize, 1, 2
	mov	guess, eax
	.IF(guess == 1)
		mov	xy, 0F0H
	.ELSE
		mov	xy, 0FFH
	.ENDIF	
	
	.IF	xy == 00FH
		jmp	UpRight
	.ElSEIF xy == 000H
		jmp	DownRight
	.ELSEIF	xy == 0F0H
		jmp	DownLeft
	.ELSEIF	xy == 0FFH
		jmp	UpLeft
	.ELSE
		jmp	StopBall
	.ENDIF
		
	UpRight:
		mov	stopComp, FALSE
		.IF	entropy == TRUE
			INVOKE	Randomize, 0, 1
			.IF eax == 1
				add	xDelta, 1
				.IF(xDelta > 3 && ignoreSpeed != TRUE)
					mov	eax, speed
					mov	xDelta, eax
				.ENDIF
			.ENDIF
			mov	entropy, FALSE
		.ENDIF
		
		cmp	ballPos.top, 0
		jl	UR_OutOfBoundTop
		INVOKE	SetPaddleArea2
		mov	ecx, paddlePos2.left
		cmp	ballPos.right, ecx
		jg	UR_OutOfBoundRight
		mov	ebx, ballPos.left
		mov	TempRect.left, ebx
		mov	ebx, ballPos.bottom
		mov	TempRect.bottom, ebx
		mov	ebx, xDelta
		add	ballPos.left, ebx
		mov	ebx, yDelta
		sub	ballPos.top, ebx
		INVOKE	SetBallArea
		mov	ebx, ballPos.top
		mov	TempRect.top, ebx
		mov	ebx, ballPos.right
		mov	TempRect.right, ebx
		INVOKE	InvalidateRect, hWnd, Addr TempRect, TRUE
		INVOKE	Sleep, 10
		jmp	UpRight
	UR_OutOfBoundTop:
		jmp	DownRight
	UR_OutOfBoundRight:
		mov	ebx, paddlePos2.top
		mov	edx, paddlePos2.bottom
		.IF (ballPos.top >= ebx && ballPos.top <= edx) || (ballPos.bottom >= ebx && ballPos.bottom <= edx)
			INVOKE	Sound, NULL, NULL
			mov	entropy, TRUE
			jmp	UpLeft
		.ELSE
			jmp	StopBall
		.ENDIF
	
	DownRight:
		mov	stopComp, FALSE
		.IF	entropy == TRUE
			INVOKE	Randomize, 0, 1
			.IF eax == 1
				add	xDelta, 1
				.IF(xDelta > 3 && ignoreSpeed != TRUE)
					mov	eax, speed
					mov	xDelta, eax
				.ENDIF
			.ENDIF
			mov	entropy, FALSE
		.ENDIF
	
		mov	edx, Rect.bottom
		cmp	ballPos.bottom, edx
		jg	DR_OutOfBoundBottom
		INVOKE	SetPaddleArea2
		mov	ecx, paddlePos2.left
		cmp	ballPos.right, ecx
		jg	DR_OutOfBoundRight
		mov	ebx, ballPos.left
		mov	TempRect.left, ebx
		mov	ebx, ballPos.top
		mov	TempRect.top, ebx
		mov ebx, xDelta
		add	ballPos.left, ebx
		mov	ebx, yDelta
		add	ballPos.top, ebx
		INVOKE	SetBallArea
		mov	ebx, ballPos.right
		mov	TempRect.right, ebx
		mov	ebx, ballPos.bottom
		mov	TempRect.bottom, ebx
		INVOKE	InvalidateRect, hWnd, Addr TempRect, TRUE
		INVOKE	Sleep, 10
		jmp	DownRight
	DR_OutOfBoundRight:
		mov	ebx, paddlePos2.top
		mov	edx, paddlePos2.bottom
		.IF (ballPos.top >= ebx && ballPos.top <= edx) || (ballPos.bottom >= ebx && ballPos.bottom <= edx)
			INVOKE	Sound, NULL, NULL
			mov	entropy, TRUE
			jmp DownLeft
		.ELSE
			jmp	StopBall
		.ENDIF
	DR_OutOfBoundBottom:
		jmp UpRight
		
	DownLeft:
		.IF	entropy == TRUE
			INVOKE	Randomize, 0, 1
			.IF eax == 1
				add	xDelta, 1
				.IF(xDelta > 3 && ignoreSpeed != TRUE)
					mov	eax, speed
					mov	xDelta, eax
				.ENDIF
			.ENDIF
			mov	entropy, FALSE
		.ENDIF
	
		mov	edx, Rect.bottom
		cmp	ballPos.bottom, edx
		jg	DL_OutOfBoundBottom
		INVOKE	SetPaddleArea1
		mov	ecx, paddlePos1.right
		cmp	ballPos.left, ecx
		jl	DL_OutOfBoundLeft
		mov	ebx, ballPos.right
		mov	TempRect.right, ebx
		mov	ebx, ballPos.top
		mov	TempRect.top, ebx
		mov	ebx, xDelta
		sub	ballPos.left, ebx
		mov	ebx, yDelta
		add	ballPos.top, ebx
		INVOKE	SetBallArea
		mov	ebx, ballPos.bottom
		mov	TempRect.bottom, ebx
		mov	ebx, ballPos.left
		mov	TempRect.left, ebx
		INVOKE	InvalidateRect, hWnd, Addr TempRect, TRUE
		INVOKE	Sleep, 10
		jmp	DownLeft
	DL_OutOfBoundBottom:
		jmp	UpLeft
	DL_OutOfBoundLeft:
		INVOKE	SetPaddleArea1
		mov	ebx, paddlePos1.top
		mov	edx, paddlePos1.bottom
		.IF (ballPos.top >= ebx && ballPos.top <= edx) || (ballPos.bottom >= ebx && ballPos.bottom <= edx)
			INVOKE	Sound, NULL, NULL
			mov	entropy, TRUE
			INVOKE	CreateThread, NULL, 0, Addr Computer, hWnd, 0, Addr CompThrd
			mov	hCompThrd, eax
			jmp	DownRight
		.ELSEIF
			jmp	StopBall
		.ENDIF
		
	UpLeft:
		.IF	entropy == TRUE
			INVOKE	Randomize, 0, 1
			.IF eax == 1
				add	xDelta, 1
				.IF(xDelta > 3 && ignoreSpeed != TRUE)
					mov	eax, speed
					mov	xDelta, eax
				.ENDIF
			.ENDIF
			mov	entropy, FALSE
		.ENDIF
		
		cmp	ballPos.top, 0
		jl	UL_OutOfBoundTop
		INVOKE	SetPaddleArea1
		mov	ecx, paddlePos1.right
		cmp	ballPos.left, ecx
		jl	UL_OutOfBoundLeft
		mov	ebx, ballPos.right
		mov	TempRect.right, ebx
		mov	ebx, ballPos.bottom
		mov	TempRect.bottom, ebx
		mov	ebx, xDelta
		sub	ballPos.left, ebx
		mov	ebx, yDelta
		sub	ballPos.top, ebx
		INVOKE	SetBallArea
		mov	ebx, ballPos.left
		mov	TempRect.left, ebx
		mov	ebx, ballPos.top
		mov	TempRect.top, ebx
		INVOKE	InvalidateRect, hWnd, Addr TempRect, TRUE
		INVOKE	Sleep, 10
		jmp	UpLeft
	UL_OutOfBoundLeft:
		INVOKE	SetPaddleArea1
		mov	ebx, paddlePos1.top
		mov	edx, paddlePos1.bottom
		.IF (ballPos.top >= ebx && ballPos.top <= edx) || (ballPos.bottom >= ebx && ballPos.bottom <= edx)
			INVOKE	Sound, NULL, NULL
			mov	entropy, TRUE
			INVOKE	CreateThread, NULL, 0, Addr Computer, hWnd, 0, Addr CompThrd
			mov	hCompThrd, eax
			jmp	UpRight
		.ELSE
			jmp	StopBall
		.ENDIF
	UL_OutOfBoundTop:
		jmp	DownLeft
		
	StopBall:
		mov	stopComp, TRUE
		mov	resumePlay, FALSE
	ret
MoveBall	ENDP

;Sets the rectangualr demensions of the ball. Once the top, left (or upper-left of rectangle) points are known, then the other points can be determined.
SetBallArea	PROC
	mov	edi, ballPos.left
	add	edi, ballStruct.bmWidth
	mov	ballPos.right, edi
	mov	edi, ballPos.top
	add	edi, ballStruct.bmHeight
	mov	ballPos.bottom, edi
	ret
SetBallArea	ENDP

;Sets the rectangular demensions for the left paddle
SetPaddleArea1	PROC
	mov	edi, paddlePos1.left
	add	edi, padStruct.bmWidth
	mov	paddlePos1.right, edi
	mov	edi, paddlePos1.top
	add	edi, padStruct.bmHeight
	mov	paddlePos1.bottom, edi
	ret
SetPaddleArea1	ENDP

;Sets the demensions for the right paddle
SetPaddleArea2	PROC
	mov	edi, paddlePos2.left
	add	edi, padStruct.bmWidth
	mov	paddlePos2.right, edi
	mov	edi, paddlePos2.top
	add	edi, padStruct.bmHeight
	mov	paddlePos2.bottom, edi
	ret
SetPaddleArea2	ENDP

;controls the upward motion of the left paddle
MovePaddleUp1	PROC	hWnd:DWORD
		mov	eax, paddlePos1.left
		mov	TempRect.left, eax
		INVOKE	SetPaddleArea1
		mov	eax, paddlePos1.right
		mov	TempRect.right, eax
		mov	eax, paddlePos1.bottom
		mov	TempRect.bottom, eax
		mov	eax, paddlePos1.top
		sub	eax, pace1
		cmp	eax, 0
		jl	ELSE_IF	;if the upper part of paddle is below the top border of client box
		mov	eax, pace1
		sub paddlePos1.top, eax
		mov	eax, paddlePos1.top
		mov	TempRect.top, eax
		jmp	END_IF
	ELSE_IF:
		mov	paddlePos1.top, 0
		mov	TempRect.top, 0
	END_IF:
		INVOKE	SetPaddleArea1
		INVOKE	InvalidateRect, hWnd, Addr TempRect, TRUE
	ret
MovePaddleUp1	ENDP

;controls the upward motion of the right paddle
MovePaddleUp2	PROC	hWnd:DWORD
	LOCAL	CompRect:RECT

		mov	eax, paddlePos2.left
		mov	CompRect.left, eax
		INVOKE	SetPaddleArea2
		mov	eax, paddlePos2.right
		mov	CompRect.right, eax
		mov	eax, paddlePos2.bottom
		mov	CompRect.bottom, eax
		mov	eax, paddlePos2.top
		sub	eax, pace2
		cmp	eax, 0
		jl	ELSE_IF	;if the upper part of paddle is below the top border of client box
		mov	eax, pace2
		sub paddlePos2.top, eax
		mov	eax, paddlePos2.top
		mov	CompRect.top, eax
		jmp	END_IF
	ELSE_IF:
		mov	paddlePos2.top, 0
		mov	CompRect.top, 0
	END_IF:
		INVOKE	SetPaddleArea2
		INVOKE	InvalidateRect, hWnd, Addr CompRect, TRUE
	ret
MovePaddleUp2	ENDP

;controls the downward motion of the left paddle
MovePaddleDown1	PROC	hWnd:DWORD
	LOCAL Rect:RECT
	
		INVOKE	GetClientRect, hWnd, Addr Rect
		mov	eax, paddlePos1.left
		mov	TempRect.left, eax
		mov	eax, paddlePos1.top
		mov	TempRect.top, eax
		INVOKE	SetPaddleArea1
		mov	eax, paddlePos1.right
		mov	TempRect.right, eax
		mov	eax, paddlePos1.bottom
		add	eax, pace1
		cmp	eax, Rect.bottom
		jg	ELSE_IF1
		mov	eax, pace1
		add	paddlePos1.top, eax
		INVOKE	SetPaddleArea1
		mov	eax, paddlePos1.bottom
		mov	TempRect.bottom, eax
		jmp	END_IF1
	ELSE_IF1:
		mov	eax, Rect.bottom
		mov	paddlePos1.bottom, eax
		mov	TempRect.bottom, eax
		sub	eax, padStruct.bmHeight
		mov	paddlePos1.top, eax
	END_IF1:
		INVOKE	SetPaddleArea1
		INVOKE	InvalidateRect, hWnd, Addr TempRect, TRUE
	ret
MovePaddleDown1	ENDP

;controls the downward motion of the right paddle
MovePaddleDown2	PROC	hWnd:DWORD
	LOCAL Rect:RECT
	LOCAL CompRect:RECT
	
		INVOKE	GetClientRect, hWnd, Addr Rect
		mov	eax, paddlePos2.left
		mov	CompRect.left, eax
		INVOKE	SetPaddleArea2
		mov	eax, paddlePos2.right
		mov	CompRect.right, eax
		mov	eax, paddlePos2.top
		mov	CompRect.top, eax
		mov	eax, paddlePos2.bottom
		add	eax, pace2
		cmp	eax, Rect.bottom
		jg	ELSE_IF1
		mov	eax, pace2
		add	paddlePos2.top, eax
		INVOKE	SetPaddleArea2
		mov	eax, paddlePos2.bottom
		mov	CompRect.bottom, eax
		jmp	END_IF1
	ELSE_IF1:
		mov	eax, Rect.bottom
		mov	paddlePos2.bottom, eax
		mov	CompRect.bottom, eax
		sub	eax, padStruct.bmHeight
		mov	paddlePos2.top, eax
	END_IF1:
		INVOKE	SetPaddleArea2
		INVOKE	InvalidateRect, hWnd, Addr CompRect, TRUE
	ret
MovePaddleDown2	ENDP

Sound PROC	freq:DWORD, Dur:DWORD
	mov	eax, sndFreq
	mov	ebx, sndDur
	
	.IF	freq != NULL && Dur != NULL
		mov	eax, freq
		mov	ebx, Dur
	.ENDIF
	
	.IF	sndEnable == TRUE
		INVOKE	Beep, eax, ebx
	.ENDIF
	ret
Sound	ENDP

;random-number generator
Randomize	PROC From:DWORD, To:DWORD
	rdtsc
	INVOKE	MRandomInit, eax
	INVOKE	MIRandom, From, To
	ret
Randomize	ENDP

END	start	;Program starts from the address of this label